import * as Effect from 'effect/Effect';
import { hasProperty } from 'effect/Predicate';
import * as Stream from 'effect/Stream';
import { VersionedImpl } from './Versioned.js';
export const ComputedTypeId = Symbol.for('@typed/LazyRef/Computed');
/**
 * @internal
 */
export function makeComputed(get, changes, version) {
    return new ComputedImpl(get, changes, version);
}
/**
 * @internal
 */
export function fromVersioned(versioned) {
    return new ComputedImpl(versioned.get, versioned.changes, versioned.version);
}
const variance = {
    _A: (_) => _,
    _E: (_) => _,
    _R: (_) => _,
};
class ComputedImpl extends VersionedImpl {
    [ComputedTypeId] = variance;
}
export function isComputed(value) {
    return hasProperty(value, ComputedTypeId);
}
export function computedFromTag(tag, f) {
    return new ComputedImpl(Effect.flatMap(tag, f), Stream.unwrap(Effect.map(tag, (s) => f(s).changes)), Effect.flatMap(tag, (s) => f(s).version));
}
//# sourceMappingURL=Computed.js.map